{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixos-unstable";

    disko = {
      url = "github:nix-community/disko";
      inputs.nixpkgs.follows = "nixpkgs";
    };
    nixos-generators = {
      url = "github:nix-community/nixos-generators";
      inputs.nixpkgs.follows = "nixpkgs";
    };
  };

  outputs = {
    self,
    nixpkgs,
    nixos-generators,
    ...
  } @ inputs: let
    inherit (self) outputs;
  in {
    nixosConfigurations = {
      m3-zelda = nixpkgs.lib.nixosSystem {
        specialArgs = {
          inherit inputs outputs;
          isImageTarget = false;
        };
        system = "x86_64-linux";
        modules = [
          ./hosts/m3-zelda
          inputs.disko.nixosModules.disko
        ];
      };
    };
    qcow = nixos-generators.nixosGenerate {
      specialArgs = {
        inherit inputs outputs;
        isImageTarget = true;
      };
      system = "x86_64-linux";
      modules = [
        ./hosts/m3-zelda
      ];
      format = "qcow-efi";
    };
    proxmox = nixos-generators.nixosGenerate {
      specialArgs = {
        inherit inputs outputs;
        isImageTarget = true;
      };
      system = "x86_64-linux";
      modules = [
        ./hosts/m3-zelda
      ];
      format = "proxmox-lxc";
    };
  };
}
